(1) Create a custom TableSlicerData.
(2) Inherit the TableSlicerData API function.
(3) Create your function to invoke related TableSlicerData API function.
(4) Create your slicer which relates to your TableSlicerData.
(5) Build slicer UI and invoke the doFilter function.
(6) Add data to spread and create a table.
(7) Create your TableSlicerData and attach it to your slicer. Add slicer to DOM tree.
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss'));
var sheet = spread.getActiveSheet();
sheet.suspendPaint();
var rowCount = 200;
sheet.setRowCount(rowCount);
var cityCount = cities.length;
sheet.setValue(0, 0, 'Continent');
sheet.setValue(0, 1, 'Country');
sheet.setValue(0, 2, 'City');
sheet.setValue(0, 3, 'Amount');
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 100);
sheet.setColumnWidth(2, 100);
sheet.setColumnWidth(3, 100);
for (var row = 1; row < rowCount; row++) {
var cityIndex = Math.floor(cityCount * Math.random());
var city = cities[cityIndex];
var country = getCountry(city);
var continent = getContinent(country);
sheet.setValue(row, 0, continent);
sheet.setValue(row, 1, country);
sheet.setValue(row, 2, city);
sheet.setValue(row, 3, Math.floor(10000 * Math.random()));
}
sheet.tables.add('table1', 0, 0, rowCount, 4, GC.Spread.Sheets.Tables.TableThemes.light19);
sheet.resumePaint();
var table = sheet.tables.find(0, 0);
var dataSource = new TreeSlicerData(table, [ 'Continent', 'Country', 'City' ]);
var treeSlicer = new TreeSlicer(dataSource, [ 'Continent', 'Country', 'City' ]);
document.getElementById('slicer_Tree').appendChild(treeSlicer.getDOMElement());
};
var cities = [
'New York',
'Los Angeles',
'Chicago',
'Bei Jing',
'Shang Hai',
'Xi An',
'Tokyo',
'Osaka',
'Yokohama',
'London',
'Liverpool',
'Manchester'
];
function getCountry(city) {
switch (city) {
case 'New York':
case 'Los Angeles':
case 'Chicago':
return 'USA';
case 'Bei Jing':
case 'Shang Hai':
case 'Xi An':
return 'China';
case 'London':
case 'Liverpool':
case 'Manchester':
return 'UK';
}
return 'Japan';
}
function getContinent(country) {
switch (country) {
case 'USA':
return 'North America';
case 'UK':
return 'Europe';
}
return 'Asia';
}
function TreeSlicerData(table, treeColumns) {
GC.Spread.Sheets.Slicers.TableSlicerData.call(this, table);
this.listeners = [];
this.suspended = false;
this.treeColumns = treeColumns;
this.lastFilterPath = [];
}
TreeSlicerData.prototype = GC.Spread.Sheets.Slicers.TableSlicerData.prototype;
TreeSlicerData.prototype.constructor = TreeSlicerData;
TreeSlicerData.prototype.buildDataTree = function() {
var treeData = (this.treeData = {});
this.build(treeData, this.treeColumns, 0, null);
};
TreeSlicerData.prototype.build = function(parentData, treeColumns, index, parentIndexes) {
var columnName = treeColumns[index];
var currentData;
var exclusiveIndexes = [];
var map = {};
if (!parentIndexes) {
var datas = this.getExclusiveData(columnName);
for (var k = 0; k < datas.length; k++) {
exclusiveIndexes.push(k);
map[k] = this.getRowIndexes(columnName, k);
}
} else {
for (var k = 0; k < parentIndexes.length; k++) {
var exclusivaIndex = this.getExclusiveRowIndex(columnName, parentIndexes[k]);
if (!map[exclusivaIndex]) {
map[exclusivaIndex] = [];
exclusiveIndexes.push(exclusivaIndex);
}
map[exclusivaIndex].push(parentIndexes[k]);
}
}
parentData.column = columnName;
if (!parentData.indexes) {
parentData.indexes = [];
}
for (var dateIndex = 0; dateIndex < exclusiveIndexes.length; dateIndex++) {
var exclusivaIndex = exclusiveIndexes[dateIndex];
var dataValue = this.getExclusiveData(columnName)[exclusivaIndex];
parentData.indexes.push(exclusivaIndex);
if (index + 1 < treeColumns.length) {
currentData = parentData[exclusivaIndex] = { indexes: [], value: dataValue };
this.build(currentData, treeColumns, index + 1, map[exclusivaIndex]);
} else {
currentData = parentData[exclusivaIndex] = map[exclusivaIndex];
currentData.value = dataValue;
}
}
};
TreeSlicerData.prototype.filter = function(path) {
this.suspended = true;
if (this.lastFilterPath) {
for (var i = 0; i < this.lastFilterPath.length; i++) {
this.doUnfilter(this.treeColumns[i]);
}
}
this.lastFilterPath = path;
var current = this.treeData;
for (var i = 0; i < path.length; i++) {
var exclusiveIndex = current.indexes ? current.indexes[path[i]] : path[i];
current = current[exclusiveIndex];
if (i === path.length - 1) {
this.suspended = false;
}
this.doFilter(this.treeColumns[i], { exclusiveRowIndexes: [ exclusiveIndex ] });
}
};
TreeSlicerData.prototype.clearFilter = function() {
this.suspended = true;
if (this.lastFilterPath) {
for (var i = 0; i < this.lastFilterPath.length; i++) {
if (i === this.lastFilterPath.length - 1) {
this.suspended = false;
}
this.doUnfilter(this.treeColumns[i]);
}
}
};
TreeSlicerData.prototype.onFiltered = function(filteredIndexes, isPreview) {
if (!this.suspended) {
for (var i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({ columnIndexes: filteredIndexes, isPreview: isPreview });
}
}
};
TreeSlicerData.prototype.attachListener = function(listener) {
this.listeners.push(listener);
};
TreeSlicerData.prototype.dettachListener = function(listener) {
for (var i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
};
var root = null;
function TreeSlicer(slicerData, treeColumns) {
slicerData.buildDataTree();
this.data = slicerData;
this.slicerData = slicerData;
this.treeColumns = treeColumns;
this.treeDatas = slicerData.treeData;
this.slicerData.attachListener(this);
this.onDataLoaded();
}
TreeSlicer.prototype.constructor = TreeSlicer;
TreeSlicer.prototype.getDOMElement = function() {
return root;
};
TreeSlicer.prototype.onDataLoaded = function() {
var self = this;
var treeDatas = this.treeDatas;
var treeItems = (this.treeItems = {});
root = document.createElement('div');
root.innerHTML = '<span class="expanded"></span><span>All</span>';
treeItems.dom = root.children[1];
treeItems.allDoms = [ root.children[1] ];
treeItems.allIcons = [ root.children[0] ];
treeItems.dom.treeItem = treeItems;
self.addOneNode(treeDatas, root, treeItems, treeItems);
treeItems.allDoms[0].classList.add('treeSlicer_Item');
document.getElementById('slicer_Tree').addEventListener('mousemove',function(e){
var target = e.target;
if(target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed'){
self.hoverItem = target;
target.classList.add("hover");
}
if (self.hoverItem === target) {
return;
}
if (self.hoverItem) {
self.hoverItem.classList.remove("hover");
}
})
document.getElementById('slicer_Tree').addEventListener('mouseout',function(e){
var target = e.target;
if (self.hoverItem) {
self.hoverItem.classList.remove("hover");
self.hoverItem = null;
}
})
document.getElementById('slicer_Tree').addEventListener('click', function(e) {
var target = e.target;
var childTree = target.parentElement.children[2];
if(target.className == 'expanded'){
childTree.style.display='none';
target.classList.remove('expanded');
target.classList.add('collapsed');
}else if(target.className == 'collapsed'){
childTree.style.display='block';
target.classList.remove('collapsed');
target.classList.add('expanded');
}
})
document.getElementById('slicer_Tree').addEventListener('mousedown', function(e) {
var target = e.target;
if (target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed') {
if (self.activeItem === target) {
return;
}
if (self.activeItem) {
self.activeItem.classList.remove('active');
self.setSelect(self.activeItem.treeItem, false);
}
self.activeItem = target;
var treeItem = self.activeItem.treeItem;
self.setSelect(self.activeItem.treeItem, true);
target.classList.add('active');
if (treeItem === treeItems) {
self.data.clearFilter();
} else if (treeItem) {
var path = [ treeItem.index ];
treeItem = treeItem.parent;
while (treeItem && treeItem.parent) {
path.unshift(treeItem.index);
treeItem = treeItem.parent;
}
self.data.filter(path);
}
}
});
self.activeItem = treeItems.dom;
self.setSelect(treeItems, true);
treeItems.dom.classList.add('active');
};
TreeSlicer.prototype.setSelect = function(treeItem, isSelect) {
if (!treeItem) {
return;
}
if (isSelect) {
treeItem.dom.classList.add('select');
} else {
treeItem.dom.classList.remove('select');
}
for (var i = 0; i < treeItem.children.length; i++) {
this.setSelect(treeItem.children[i], isSelect);
}
};
TreeSlicer.prototype.addOneNode = function(treeDatas, parent, parentItem, rootItem) {
var indexes = treeDatas.indexes;
var current = document.createElement('ul');
parent.appendChild(current);
parentItem.children = [];
var currentItem;
if (indexes) {
for (var i = 0; i < indexes.length; i++) {
var childData = treeDatas[indexes[i]];
var value = childData.value;
var childDom = this.addItem(current, value, parentItem, i, rootItem, false);
currentItem = childDom.children[1].treeItem;
this.addOneNode(childData, childDom, currentItem, rootItem);
}
} else {
parent.children[0].classList.remove('expanded');
}
};
TreeSlicer.prototype.addItem = function(current, value, parentItem, index, rootItem, isLeaf) {
var childDom = document.createElement('li');
if (isLeaf) {
childDom.innerHTML = '<span></span><span>' + value + '</span>';
} else {
childDom.innerHTML = '<span class="expanded"></span><span>' + value + '</span>';
}
current.appendChild(childDom);
var content = childDom.children[1];
rootItem.allDoms.push(content);
rootItem.allIcons.push(childDom.children[0]);
var item = { dom: content, parent: parentItem, index: index };
parentItem.children.push(item);
content.treeItem = item;
parentItem.children.push();
if (isLeaf) {
current.style.display = 'none';
}
return childDom;
};
TreeSlicer.prototype.onFiltered = function(data) {};
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial" style="height:100%">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p class="desc">Click on different items in this tree to filter by those items.</p>
<div style="height: 440px;position: relative">
<div id="slicer_Tree"></div>
</div>
</div>
</div>
</body>
</html>
.hover {
background-color: lightgray;
font-weight: 700 !important;
}
.select {
font-weight: 700 !important;
color: blue;
}
.active {
font-weight: 700 !important;
color: red;
}
.treeSlicer_Item {
cursor: pointer;
}
.expanded {
background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAR0lEQVRYR+3UUQ0AIAwD0Zsi/LsYiiDDRPm4GWjzkrUIX4XzsYACCiigwAg0sEKT3FPghMJfrAUU+EIg+YbbJVRAAQUUUOAC99IJunjjuhUAAAAASUVORK5CYII=);
background-repeat: no-repeat;
background-position: center;
background-size: 10px 10px;
background-color: #d3d3d3;
height: 16px;
width: 16px;
float: left;
cursor: pointer;
}
.collapsed {
background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAaklEQVRYR+2WSwrAIBQD44na3v8SeqIWodsq000/jFuT8BgwvhJ+apLlwtbvNhJZiPjU7hMPykRiB5CABCTwWwKjbr/R1MhSexXPuh0lUrEDSOAVBJ58hs2NSAISkIAEPklg9He0JCvZig6rOyO69wJo3QAAAABJRU5ErkJggg==);
background-repeat: no-repeat;
background-position: center;
background-size: 10px 10px;
background-color: #d3d3d3;
height: 16px;
width: 16px;
float: left;
cursor: pointer;
}
li {
list-style: none;
}
.desc{
padding:2px 10px;
background-color:#F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
span {
line-height: 18px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

(1) Create a custom TableSlicerData.
(2) Inherit the TableSlicerData API function.
(3) Create your function to invoke related TableSlicerData API function.
(4) Create your slicer which relates to your TableSlicerData.
(5) Build slicer UI and invoke the doFilter function.
(6) Add data to spread and create a table.
(7) Create your TableSlicerData and attach it to your slicer. Add slicer to DOM tree.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet :rowCount=200>
<gc-column :width=100></gc-column>
<gc-column :width=100></gc-column>
<gc-column :width=100></gc-column>
<gc-column :width=100></gc-column>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p class="desc">Click on different items in this tree to filter by those items.</p>
<div class="slicer-tree-container">
<div id="slicer_Tree"></div>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-slicers";
const spreadRef = ref(null);
function initSpread(spread) {
spreadRef.value = spread;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let cityCount = cities.length;
let rowCount = sheet.getRowCount();
sheet.setValue(0, 0, 'Continent');
sheet.setValue(0, 1, 'Country');
sheet.setValue(0, 2, 'City');
sheet.setValue(0, 3, 'Amount');
for (let row = 1; row < rowCount; row++) {
let cityIndex = Math.floor(cityCount * Math.random());
let city = cities[cityIndex];
let country = getCountry(city);
let continent = getContinent(country);
sheet.setValue(row, 0, continent);
sheet.setValue(row, 1, country);
sheet.setValue(row, 2, city);
sheet.setValue(row, 3, Math.floor(10000 * Math.random()));
}
sheet.tables.add('table1', 0, 0, rowCount, 4, GC.Spread.Sheets.Tables.TableThemes.light19);
sheet.resumePaint();
let table = sheet.tables.find(0, 0);
let dataSource = new TreeSlicerData(table, ['Continent', 'Country', 'City']);
let treeSlicer = new TreeSlicer(dataSource, ['Continent', 'Country', 'City']);
document.getElementById('slicer_Tree').appendChild(treeSlicer.getDOMElement());
}
const cities = [
'New York',
'Los Angeles',
'Chicago',
'Bei Jing',
'Shang Hai',
'Xi An',
'Tokyo',
'Osaka',
'Yokohama',
'London',
'Liverpool',
'Manchester'
];
function getCountry(city) {
switch (city) {
case 'New York':
case 'Los Angeles':
case 'Chicago':
return 'USA';
case 'Bei Jing':
case 'Shang Hai':
case 'Xi An':
return 'China';
case 'London':
case 'Liverpool':
case 'Manchester':
return 'UK';
}
return 'Japan';
}
function getContinent(country) {
switch (country) {
case 'USA':
return 'North America';
case 'UK':
return 'Europe';
}
return 'Asia';
}
class TreeSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData {
constructor(table, treeColumns) {
super(table);
this.listeners = [];
this.suspended = false;
this.treeColumns = treeColumns;
this.lastFilterPath = [];
}
buildDataTree() {
let treeData = (this.treeData = {});
this.build(treeData, this.treeColumns, 0, null);
}
build(parentData, treeColumns, index, parentIndexes) {
let columnName = treeColumns[index];
let currentData;
let exclusiveIndexes = [];
let map = {};
if (!parentIndexes) {
let datas = this.getExclusiveData(columnName);
for (let k = 0; k < datas.length; k++) {
exclusiveIndexes.push(k);
map[k] = this.getRowIndexes(columnName, k);
}
} else {
for (let k = 0; k < parentIndexes.length; k++) {
let exclusivaIndex = this.getExclusiveRowIndex(columnName, parentIndexes[k]);
if (!map[exclusivaIndex]) {
map[exclusivaIndex] = [];
exclusiveIndexes.push(exclusivaIndex);
}
map[exclusivaIndex].push(parentIndexes[k]);
}
}
parentData.column = columnName;
if (!parentData.indexes) {
parentData.indexes = [];
}
for (let dateIndex = 0; dateIndex < exclusiveIndexes.length; dateIndex++) {
let exclusivaIndex = exclusiveIndexes[dateIndex];
let dataValue = this.getExclusiveData(columnName)[exclusivaIndex];
parentData.indexes.push(exclusivaIndex);
if (index + 1 < treeColumns.length) {
currentData = parentData[exclusivaIndex] = { indexes: [], value: dataValue };
this.build(currentData, treeColumns, index + 1, map[exclusivaIndex]);
} else {
currentData = parentData[exclusivaIndex] = map[exclusivaIndex];
currentData.value = dataValue;
}
}
}
filter(path) {
this.suspended = true;
if (this.lastFilterPath) {
for (let i = 0; i < this.lastFilterPath.length; i++) {
this.doUnfilter(this.treeColumns[i]);
}
}
this.lastFilterPath = path;
let current = this.treeData;
for (let i = 0; i < path.length; i++) {
let exclusiveIndex = current.indexes ? current.indexes[path[i]] : path[i];
current = current[exclusiveIndex];
if (i === path.length - 1) {
this.suspended = false;
}
this.doFilter(this.treeColumns[i], { exclusiveRowIndexes: [exclusiveIndex] });
}
}
clearFilter() {
this.suspended = true;
if (this.lastFilterPath) {
for (let i = 0; i < this.lastFilterPath.length; i++) {
if (i === this.lastFilterPath.length - 1) {
this.suspended = false;
}
this.doUnfilter(this.treeColumns[i]);
}
}
}
onFiltered(filteredIndexes, isPreview) {
if (!this.suspended) {
for (let i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({ columnIndexes: filteredIndexes, isPreview: isPreview });
}
}
}
attachListener(listener) {
this.listeners.push(listener);
}
dettachListener(listener) {
for (let i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
}
}
class TreeSlicer {
constructor(slicerData, treeColumns) {
slicerData.buildDataTree();
this.root = null;
this.data = slicerData;
this.slicerData = slicerData;
this.treeColumns = treeColumns;
this.treeDatas = slicerData.treeData;
this.slicerData.attachListener(this);
this.onDataLoaded();
}
getDOMElement() {
return this.root;
}
onDataLoaded() {
let self = this;
let treeDatas = this.treeDatas;
let treeItems = (this.treeItems = {});
let root = document.createElement('div');
this.root = root;
root.innerHTML = '<span class="expanded"></span><span>All</span>';
treeItems.dom = root.children[1];
treeItems.allDoms = [root.children[1]];
treeItems.allIcons = [root.children[0]];
treeItems.dom.treeItem = treeItems;
self.addOneNode(treeDatas, root, treeItems, treeItems);
treeItems.allDoms[0].classList.add('treeSlicer_Item');
document.getElementById('slicer_Tree').addEventListener('mousemove', function (e) {
let target = e.target;
if (target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed') {
self.hoverItem = target;
target.classList.add("hover");
}
if (self.hoverItem === target) {
return;
}
if (self.hoverItem) {
self.hoverItem.classList.remove("hover");
}
})
document.getElementById('slicer_Tree').addEventListener('mouseout', function (e) {
let target = e.target;
if (self.hoverItem) {
self.hoverItem.classList.remove("hover");
self.hoverItem = null;
}
})
document.getElementById('slicer_Tree').addEventListener('click', function (e) {
let target = e.target;
let childTree = target.parentElement.children[2];
if (target.className == 'expanded') {
childTree.style.display = 'none';
target.classList.remove('expanded');
target.classList.add('collapsed');
} else if (target.className == 'collapsed') {
childTree.style.display = 'block';
target.classList.remove('collapsed');
target.classList.add('expanded');
}
})
document.getElementById('slicer_Tree').addEventListener('mousedown', function (e) {
let target = e.target;
if (target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed') {
if (self.activeItem === target) {
return;
}
if (self.activeItem) {
self.activeItem.classList.remove('active');
self.setSelect(self.activeItem.treeItem, false);
}
self.activeItem = target;
let treeItem = self.activeItem.treeItem;
self.setSelect(self.activeItem.treeItem, true);
target.classList.add('active');
if (treeItem === treeItems) {
self.data.clearFilter();
} else if (treeItem) {
let path = [treeItem.index];
treeItem = treeItem.parent;
while (treeItem && treeItem.parent) {
path.unshift(treeItem.index);
treeItem = treeItem.parent;
}
self.data.filter(path);
}
}
});
self.activeItem = treeItems.dom;
self.setSelect(treeItems, true);
treeItems.dom.classList.add('active');
}
setSelect(treeItem, isSelect) {
if (!treeItem) {
return;
}
if (isSelect) {
treeItem.dom.classList.add('select');
} else {
treeItem.dom.classList.remove('select');
}
for (let i = 0; i < treeItem.children.length; i++) {
this.setSelect(treeItem.children[i], isSelect);
}
}
addOneNode(treeDatas, parent, parentItem, rootItem) {
let indexes = treeDatas.indexes;
let current = document.createElement('ul');
parent.appendChild(current);
parentItem.children = [];
let currentItem;
if (indexes) {
for (let i = 0; i < indexes.length; i++) {
let childData = treeDatas[indexes[i]];
let value = childData.value;
let childDom = this.addItem(current, value, parentItem, i, rootItem, false);
currentItem = childDom.children[1].treeItem;
this.addOneNode(childData, childDom, currentItem, rootItem);
}
} else {
parent.children[0].classList.remove('expanded');
}
}
addItem(current, value, parentItem, index, rootItem, isLeaf) {
let childDom = document.createElement('li');
if (isLeaf) {
childDom.innerHTML = '<span></span><span>' + value + '</span>';
} else {
childDom.innerHTML = '<span class="expanded"></span><span>' + value + '</span>';
}
current.appendChild(childDom);
let content = childDom.children[1];
rootItem.allDoms.push(content);
rootItem.allIcons.push(childDom.children[0]);
let item = { dom: content, parent: parentItem, index: index };
parentItem.children.push(item);
content.treeItem = item;
parentItem.children.push();
if (isLeaf) {
current.style.display = 'none';
}
return childDom;
}
onFiltered(data) { }
}
</script>
<style scoped>
#app {
height: 100%;
}
.hover {
background-color: lightgray;
font-weight: 700 !important;
}
.select {
font-weight: 700 !important;
color: blue;
}
.active {
font-weight: 700 !important;
color: red;
}
.treeSlicer_Item {
cursor: pointer;
}
.expanded {
background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAR0lEQVRYR+3UUQ0AIAwD0Zsi/LsYiiDDRPm4GWjzkrUIX4XzsYACCiigwAg0sEKT3FPghMJfrAUU+EIg+YbbJVRAAQUUUOAC99IJunjjuhUAAAAASUVORK5CYII=);
background-repeat: no-repeat;
background-position: center;
background-size: 10px 10px;
background-color: #d3d3d3;
height: 16px;
width: 16px;
float: left;
cursor: pointer;
}
.collapsed {
background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAaklEQVRYR+2WSwrAIBQD44na3v8SeqIWodsq000/jFuT8BgwvhJ+apLlwtbvNhJZiPjU7hMPykRiB5CABCTwWwKjbr/R1MhSexXPuh0lUrEDSOAVBJ58hs2NSAISkIAEPklg9He0JCvZig6rOyO69wJo3QAAAABJRU5ErkJggg==);
background-repeat: no-repeat;
background-position: center;
background-size: 10px 10px;
background-color: #d3d3d3;
height: 16px;
width: 16px;
float: left;
cursor: pointer;
}
li {
list-style: none;
}
.desc {
padding: 2px 10px;
background-color: #F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
span {
line-height: 18px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.slicer-tree-container {
height: 440px;
position: relative;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Tree Slicer

You can customize TableSlicerData to meet your needs. Here is how to use a tree slicer:

Description
app.jsx
app-func.jsx
panel.jsx
index.html
styles.css
Copy to CodeMine

(1) Create a custom TableSlicerData.

    function TreeSlicerData(table, treeColumns) {
        GC.Spread.Sheets.Slicers.TableSlicerData.call(this, table);
        this.listeners = [];
        this.suspended = false;
        ...
    }
    TreeSlicerData.prototype = GC.Spread.Sheets.Slicers.TableSlicerData.prototype;
    TreeSlicerData.prototype.constructor = TreeSlicerData;

(2) Inherit the TableSlicerData API function.

    // inherit attachListener function of TableSlicerData
    TreeSlicerData.prototype.attachListener = function (listener) {
        // Some code omitted here, you can see it on the right.
        ...
    };
    // inherit detachListener function of TableSlicerData
    TreeSlicerData.prototype.detachListener = function (listener) {
        ...
    };

(3) Create your function to invoke related TableSlicerData API function.

    TreeSlicerData.prototype.filter = function (path) {
        this.suspended = true;
        if (this.lastFilterPath) {
            for (var i = 0; i < this._lastFilterPath.length; i++) {
                // invoke TableSlicerData API function
                this.doUnfilter(this.treeColumns[i]);
            }
        }
        this.lastFilterPath = path;
        var current = this.treeData;
        for (var i = 0; i < path.length; i++) {
            ...
            // invoke TableSlicerData API function
            this.doFilter(this.treeColumns[i], { exclusiveRowIndexes: [exclusiveIndex] });
        }
    };

(4) Create your slicer which relates to your TableSlicerData.

    function TreeSlicer(slicerData, treeColumns) {
      slicerData.buildDataTree();
      this.data = slicerData;
      this.slicerData = slicerData;
      this.treeColumns = treeColumns;
      this.treeDatas = slicerData.treeData;
      this.slicerData.attachListener(this);
      this.onDataLoaded();
    }
    TreeSlicer.prototype.constructor = TreeSlicer;

(5) Build slicer UI and invoke the doFilter function.

    TreeSlicer.prototype.onDataLoaded = function () {
        ...
        $(treeItems.allDoms).addClass('treeSlicer_Item').mousedown(function (obj) {
            ...
            if (treeItem === treeItems) {
                self.data.clearFilter();    // invoke TableSlicerData function
            }
            else if (treeItem) {
            if (treeItem === treeItems) {
                ...
                self.data.filter(path);    // invoke TableSlicerData function
            }
        });
        ...
    };

(6) Add data to spread and create a table.

    spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss'));
    var sheet = spread.getActiveSheet();
    sheet.suspendPaint();
    // add data to sheet
    ...
    sheet.tables.add('table1', 0, 0, 6, 5);
    sheet.resumePaint();

(7) Create your TableSlicerData and attach it to your slicer. Add slicer to DOM tree.

    var table = sheet.tables.find(0, 0);
    var dataSource = new TreeSlicerData(table, ['Continent', 'Country', 'City']);
    var treeSlicer = new TreeSlicer(dataSource, ['Continent', 'Country', 'City']);
    document.getElementById('slicer_Tree').appendChild(treeSlicer.getDOMElement());
(1) Create a custom TableSlicerData. (2) Inherit the TableSlicerData API function. (3) Create your function to invoke related TableSlicerData API function. (4) Create your slicer which relates to your TableSlicerData. (5) Build slicer UI and invoke the doFilter function. (6) Add data to spread and create a table. (7) Create your TableSlicerData and attach it to your slicer. Add slicer to DOM tree.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app'));
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-slicers"; import Panel from './panel'; import { SpreadSheets, Worksheet, Column } from '@mescius/spread-sheets-react'; const { useState } = React; let dataSource, setSource, activeItem, hoveritem; const cities = [ 'New York', 'Los Angeles', 'Chicago', 'Bei Jing', 'Shang Hai', 'Xi An', 'Tokyo', 'Osaka', 'Yokohama', 'London', 'Liverpool', 'Manchester' ]; export const AppFunc = () => { const [dataSource, setDataSource] = useState(null); setSource = setDataSource; return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => initSpread(spread, setDataSource)}> <Worksheet> <Column width={100}></Column> <Column width={100}></Column> <Column width={100}></Column> <Column width={100}></Column> </Worksheet> </SpreadSheets> </div> <Panel onMouseMove={(e) => { onMouseMove(e) }} dataSource={dataSource} onMouseOut={(e) => { onMouseOut(e) }} onClick={(e) => { onClick(e) }} onMouseDown={(e) => { onMouseDown(e) }} ></Panel> </div> ) } function onMouseDown(e) { var target = e.target; if (target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed') { if (activeItem) { delete activeItem.active; } let dataItem = Object.assign({}, dataSource.treeData); if (!target.id) { dataSource.clearFilter(); dataItem.active = true; setSource(dataItem); } else { var path = target.id.split(" ").map((item) => { return parseInt(item); }); let data = dataItem; let pathCopy = [...path]; while(path.length > 0) { let index = path.shift(); dataItem = dataItem[dataItem.indexes[index]]; } dataItem.active = true; activeItem = dataItem; dataSource.filter(pathCopy); setSource(data); } } } function onClick(e) { var target = e.target; var childTree = target.parentElement.children[2]; if (target.className == 'expanded') { childTree.style.display = 'none'; target.classList.remove('expanded'); target.classList.add('collapsed'); } else if (target.className == 'collapsed') { childTree.style.display = 'block'; target.classList.remove('collapsed'); target.classList.add('expanded'); } } function onMouseMove(e) { var target = e.target; if (target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed') { if (hoveritem) { delete hoveritem.hover; } let dataItem = Object.assign({}, dataSource.treeData); if (!target.id) { dataItem.hover = true; setSource(dataItem); } else { var path = target.id.split(" ").map((item) => { return parseInt(item); }); let data = dataItem; while(path.length > 0) { let index = path.shift(); dataItem = dataItem[dataItem.indexes[index]]; } dataItem.hover = true; hoveritem = dataItem; setSource(data); } } } function onMouseOut(e) { if (hoveritem) { delete hoveritem.hover; } setSource(Object.assign({}, dataSource.treeData)); } function getCountry(city) { switch (city) { case 'New York': case 'Los Angeles': case 'Chicago': return 'USA'; case 'Bei Jing': case 'Shang Hai': case 'Xi An': return 'China'; case 'London': case 'Liverpool': case 'Manchester': return 'UK'; } return 'Japan'; } function getContinent(country) { switch (country) { case 'USA': return 'North America'; case 'UK': return 'Europe'; } return 'Asia'; } function initSpread(spread) { var sheet = spread.getActiveSheet(); sheet.suspendPaint(); var rowCount = 200; sheet.setRowCount(rowCount); var cityCount = cities.length; sheet.setValue(0, 0, 'Continent'); sheet.setValue(0, 1, 'Country'); sheet.setValue(0, 2, 'City'); sheet.setValue(0, 3, 'Amount'); for (var row = 1; row < rowCount; row++) { var cityIndex = Math.floor(cityCount * Math.random()); var city = cities[cityIndex]; var country = getCountry(city); var continent = getContinent(country); sheet.setValue(row, 0, continent); sheet.setValue(row, 1, country); sheet.setValue(row, 2, city); sheet.setValue(row, 3, Math.floor(10000 * Math.random())); } sheet.tables.add('table1', 0, 0, rowCount, 4, GC.Spread.Sheets.Tables.TableThemes.light19); sheet.resumePaint(); var table = sheet.tables.find(0, 0); dataSource = new TreeSlicerData(table, ['Continent', 'Country', 'City']); dataSource.buildDataTree(); let dataItem = Object.assign({}, dataSource.treeData); dataItem.active = true; setSource(dataItem); } class TreeSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData { constructor(table, treeColumns) { super(table); this.listeners = []; this.suspended = false; this.treeColumns = treeColumns; this.lastFilterPath = []; } buildDataTree() { var treeData = (this.treeData = {}); this.build(treeData, this.treeColumns, 0, null); } build(parentData, treeColumns, index, parentIndexes) { var columnName = treeColumns[index]; var currentData; var exclusiveIndexes = []; var map = {}; if (!parentIndexes) { var datas = this.getExclusiveData(columnName); for (var k = 0; k < datas.length; k++) { exclusiveIndexes.push(k); map[k] = this.getRowIndexes(columnName, k); } } else { for (var k = 0; k < parentIndexes.length; k++) { var exclusivaIndex = this.getExclusiveRowIndex(columnName, parentIndexes[k]); if (!map[exclusivaIndex]) { map[exclusivaIndex] = []; exclusiveIndexes.push(exclusivaIndex); } map[exclusivaIndex].push(parentIndexes[k]); } } parentData.column = columnName; if (!parentData.indexes) { parentData.indexes = []; } for (var dateIndex = 0; dateIndex < exclusiveIndexes.length; dateIndex++) { var exclusivaIndex = exclusiveIndexes[dateIndex]; var dataValue = this.getExclusiveData(columnName)[exclusivaIndex]; parentData.indexes.push(exclusivaIndex); if (index + 1 < treeColumns.length) { currentData = parentData[exclusivaIndex] = { indexes: [], value: dataValue }; this.build(currentData, treeColumns, index + 1, map[exclusivaIndex]); } else { currentData = parentData[exclusivaIndex] = map[exclusivaIndex]; currentData.value = dataValue; } } } filter(path) { this.suspended = true; if (this.lastFilterPath) { for (var i = 0; i < this.lastFilterPath.length; i++) { this.doUnfilter(this.treeColumns[i]); } } this.lastFilterPath = path; var current = this.treeData; for (var i = 0; i < path.length; i++) { var exclusiveIndex = current.indexes ? current.indexes[path[i]] : path[i]; current = current[exclusiveIndex]; if (i === path.length - 1) { this.suspended = false; } this.doFilter(this.treeColumns[i], { exclusiveRowIndexes: [exclusiveIndex] }); } } clearFilter() { this.suspended = true; if (this.lastFilterPath) { for (var i = 0; i < this.lastFilterPath.length; i++) { if (i === this.lastFilterPath.length - 1) { this.suspended = false; } this.doUnfilter(this.treeColumns[i]); } } } onFiltered(filteredIndexes, isPreview) { if (!this.suspended) { for (var i = 0; i < this.listeners.length; i++) { this.listeners[i].onFiltered({ columnIndexes: filteredIndexes, isPreview: isPreview }); } } } attachListener(listener) { this.listeners.push(listener); } dettachListener(listener) { for (var i = 0; i < this.listeners.length; i++) { if (this.listeners[i] === listener) { this.listeners.splice(i); break; } } } }
import * as React from 'react'; export default function Panel(props) { const { onMouseMove, onMouseOut, onClick, onMouseDown, dataSource } = props; return ( <div class="options-container"> <p className="desc">Click on different items in this tree to filter by those items.</p> <div style={{ height: '440px', position: 'relative' }}> <div id="slicer_Tree" onMouseMove={(e) => { onMouseMove(e) }} onMouseOut={(e) => { onMouseOut(e) }} onClick={(e) => { onClick(e) }} onMouseDown={(e) => { onMouseDown(e) }}> {createDomWithDataSoyrce(dataSource)} </div> </div> </div> ); } function createDomWithDataSoyrce(dataSource) { return ( <div> <span className="expanded"> </span> <span className={dataSource && (dataSource.active ? (dataSource.hover ? 'active hover' : 'active') : (dataSource.hover ? "hover" : ""))}>All</span> <ul style={{ padding: '0' }}> { dataSource && createItemDom(dataSource) } </ul> </div> ); } function createItemDom(item, index) { return ( <ul> { item.indexes && item.indexes.map((nextitem, itemIndex) => { return ( <li> {!!item[nextitem].indexes && <span className="expanded"></span>} <span className={item[nextitem].active ? (item[nextitem].hover ? "select active hover" : "select active") : (item[nextitem].hover ? "hover select" : "select")} key={nextitem} id={index !== undefined ? index + ' ' + itemIndex : itemIndex}>{item[nextitem].value}</span> { item[nextitem].indexes && createItemDom(item[nextitem], index !== undefined ? index + ' ' + itemIndex : itemIndex) } </li> ) }) } </ul> ) }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .hover { background-color: lightgray; font-weight: 700 !important; } .select { font-weight: 700 !important; color: blue; } .active { font-weight: 700 !important; color: red; } .treeSlicer_Item { cursor: pointer; } .expanded { background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAR0lEQVRYR+3UUQ0AIAwD0Zsi/LsYiiDDRPm4GWjzkrUIX4XzsYACCiigwAg0sEKT3FPghMJfrAUU+EIg+YbbJVRAAQUUUOAC99IJunjjuhUAAAAASUVORK5CYII=); background-repeat: no-repeat; background-position: center; background-size: 10px 10px; background-color: #d3d3d3; height: 16px; width: 16px; float: left; cursor: pointer; } .collapsed { background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAaklEQVRYR+2WSwrAIBQD44na3v8SeqIWodsq000/jFuT8BgwvhJ+apLlwtbvNhJZiPjU7hMPykRiB5CABCTwWwKjbr/R1MhSexXPuh0lUrEDSOAVBJ58hs2NSAISkIAEPklg9He0JCvZig6rOyO69wJo3QAAAABJRU5ErkJggg==); background-repeat: no-repeat; background-position: center; background-size: 10px 10px; background-color: #d3d3d3; height: 16px; width: 16px; float: left; cursor: pointer; } li { list-style: none; } .desc{ padding:2px 10px; background-color:#F4F8EB; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } span { line-height: 18px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

(1) Create a custom TableSlicerData.
(2) Inherit the TableSlicerData API function.
(3) Create your function to invoke related TableSlicerData API function.
(4) Create your slicer which relates to your TableSlicerData.
(5) Build slicer UI and invoke the doFilter function.
(6) Add data to spread and create a table.
(7) Create your TableSlicerData and attach it to your slicer. Add slicer to DOM tree.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-slicers";
import './styles.css';
const cities = [
'New York',
'Los Angeles',
'Chicago',
'Bei Jing',
'Shang Hai',
'Xi An',
'Tokyo',
'Osaka',
'Yokohama',
'London',
'Liverpool',
'Manchester'
];
function getCountry(city: string) {
switch (city) {
case 'New York':
case 'Los Angeles':
case 'Chicago':
return 'USA';
case 'Bei Jing':
case 'Shang Hai':
case 'Xi An':
return 'China';
case 'London':
case 'Liverpool':
case 'Manchester':
return 'UK';
}
return 'Japan';
}
function getContinent(country: string) {
switch (country) {
case 'USA':
return 'North America';
case 'UK':
return 'Europe';
}
return 'Asia';
}
class TreeSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData {
suspended: boolean;
listeners: any[];
treeColumns: string[];
lastFilterPath: string[];
treeData: any;
constructor (table: GC.Spread.Sheets.Tables.Table, treeColumns: string[]) {
super(table);
this.listeners = [];
this.suspended = false;
this.treeColumns = treeColumns;
this.lastFilterPath = [];
}
buildDataTree () {
let treeData = (this.treeData = {});
this.build(treeData, this.treeColumns, 0, null);
}
build (parentData: any, treeColumns: string[], index: number, parentIndexes: number[]) {
let columnName = treeColumns[index];
let currentData;
let exclusiveIndexes = [];
let map = {};
if (!parentIndexes) {
let datas = this.getExclusiveData(columnName);
for (let k = 0; k < datas.length; k++) {
exclusiveIndexes.push(k);
map[k] = this.getRowIndexes(columnName, k);
}
} else {
for (let k = 0; k < parentIndexes.length; k++) {
let exclusivaIndex = this.getExclusiveRowIndex(columnName, parentIndexes[k]);
if (!map[exclusivaIndex]) {
map[exclusivaIndex] = [];
exclusiveIndexes.push(exclusivaIndex);
}
map[exclusivaIndex].push(parentIndexes[k]);
}
}
parentData.column = columnName;
if (!parentData.indexes) {
parentData.indexes = [];
}
for (let dateIndex = 0; dateIndex < exclusiveIndexes.length; dateIndex++) {
let exclusivaIndex = exclusiveIndexes[dateIndex];
let dataValue = this.getExclusiveData(columnName)[exclusivaIndex];
parentData.indexes.push(exclusivaIndex);
if (index + 1 < treeColumns.length) {
currentData = parentData[exclusivaIndex] = { indexes: [], value: dataValue };
this.build(currentData, treeColumns, index + 1, map[exclusivaIndex]);
} else {
currentData = parentData[exclusivaIndex] = map[exclusivaIndex];
currentData.value = dataValue;
}
}
}
filter (path: string[]) {
this.suspended = true;
if (this.lastFilterPath) {
for (let i = 0; i < this.lastFilterPath.length; i++) {
this.doUnfilter(this.treeColumns[i]);
}
}
this.lastFilterPath = path;
let current = this.treeData;
for (let i = 0; i < path.length; i++) {
let exclusiveIndex = current.indexes ? current.indexes[path[i]] : path[i];
current = current[exclusiveIndex];
if (i === path.length - 1) {
this.suspended = false;
}
this.doFilter(this.treeColumns[i], { exclusiveRowIndexes: [ exclusiveIndex ] });
}
}
clearFilter () {
this.suspended = true;
if (this.lastFilterPath) {
for (let i = 0; i < this.lastFilterPath.length; i++) {
if (i === this.lastFilterPath.length - 1) {
this.suspended = false;
}
this.doUnfilter(this.treeColumns[i]);
}
}
}
onFiltered (filteredIndexes: number[], isPreview: boolean) {
if (!this.suspended) {
for (let i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({ columnIndexes: filteredIndexes, isPreview: isPreview });
}
}
}
attachListener (listener: any) {
this.listeners.push(listener);
}
dettachListener (listener: any) {
for (let i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
}
}
class TreeSlicer {
root: HTMLElement;
data: any;
slicerData: TreeSlicerData;
treeColumns: string[];
treeDatas: any;
treeItems: any;
hoverItem: any;
activeItem: any;
constructor (slicerData: TreeSlicerData, treeColumns: string[]) {
slicerData.buildDataTree();
this.root = null;
this.data = slicerData;
this.slicerData = slicerData;
this.treeColumns = treeColumns;
this.treeDatas = slicerData.treeData;
this.slicerData.attachListener(this);
this.onDataLoaded();
}
getDOMElement () {
return this.root;
}
onDataLoaded () {
let self = this;
let treeDatas = this.treeDatas;
let treeItems: any = (this.treeItems = {});
let root = document.createElement('div');
this.root = root;
root.innerHTML = '<span class="expanded"></span><span>All</span>';
treeItems.dom = root.children[1];
treeItems.allDoms = [ root.children[1] ];
treeItems.allIcons = [ root.children[0] ];
treeItems.dom.treeItem = treeItems;
self.addOneNode(treeDatas, root, treeItems, treeItems);
treeItems.allDoms[0].classList.add('treeSlicer_Item');
document.getElementById('slicer_Tree').addEventListener('mousemove',function(e){
let target: any = e.target;
if(target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed'){
self.hoverItem = target;
target.classList.add("hover");
}
if (self.hoverItem === target) {
return;
}
if (self.hoverItem) {
self.hoverItem.classList.remove("hover");
}
})
document.getElementById('slicer_Tree').addEventListener('mouseout',function(e){
if (self.hoverItem) {
self.hoverItem.classList.remove("hover");
self.hoverItem = null;
}
})
document.getElementById('slicer_Tree').addEventListener('click', function(e) {
let target: any = e.target;
let childTree = target.parentElement.children[2];
if(target.className == 'expanded'){
childTree.style.display='none';
target.classList.remove('expanded');
target.classList.add('collapsed');
}else if(target.className == 'collapsed'){
childTree.style.display='block';
target.classList.remove('collapsed');
target.classList.add('expanded');
}
})
document.getElementById('slicer_Tree').addEventListener('mousedown', function(e) {
let target: any = e.target;
if (target.tagName == 'SPAN' && target.className !== 'expanded' && target.className !== 'collapsed') {
if (self.activeItem === target) {
return;
}
if (self.activeItem) {
self.activeItem.classList.remove('active');
self.setSelect(self.activeItem.treeItem, false);
}
self.activeItem = target;
let treeItem = self.activeItem.treeItem;
self.setSelect(self.activeItem.treeItem, true);
target.classList.add('active');
if (treeItem === treeItems) {
self.data.clearFilter();
} else if (treeItem) {
let path = [ treeItem.index ];
treeItem = treeItem.parent;
while (treeItem && treeItem.parent) {
path.unshift(treeItem.index);
treeItem = treeItem.parent;
}
self.data.filter(path);
}
}
});
self.activeItem = treeItems.dom;
self.setSelect(treeItems, true);
treeItems.dom.classList.add('active');
}
setSelect (treeItem: any, isSelect: boolean) {
if (!treeItem) {
return;
}
if (isSelect) {
treeItem.dom.classList.add('select');
} else {
treeItem.dom.classList.remove('select');
}
for (let i = 0; i < treeItem.children.length; i++) {
this.setSelect(treeItem.children[i], isSelect);
}
}
addOneNode (treeDatas: any, parent: any, parentItem: any, rootItem: any) {
let indexes = treeDatas.indexes;
let current = document.createElement('ul');
parent.appendChild(current);
parentItem.children = [];
let currentItem;
if (indexes) {
for (let i = 0; i < indexes.length; i++) {
let childData = treeDatas[indexes[i]];
let value = childData.value;
let childDom = this.addItem(current, value, parentItem, i, rootItem, false);
currentItem = (<any> childDom.children[1]).treeItem;
this.addOneNode(childData, childDom, currentItem, rootItem);
}
} else {
parent.children[0].classList.remove('expanded');
}
}
addItem (current: any, value: any, parentItem: any, index: any, rootItem: any, isLeaf: boolean) {
let childDom = document.createElement('li');
if (isLeaf) {
childDom.innerHTML = '<span></span><span>' + value + '</span>';
} else {
childDom.innerHTML = '<span class="expanded"></span><span>' + value + '</span>';
}
current.appendChild(childDom);
let content: any = childDom.children[1];
rootItem.allDoms.push(content);
rootItem.allIcons.push(childDom.children[0]);
let item = { dom: content, parent: parentItem, index: index };
parentItem.children.push(item);
content.treeItem = item;
parentItem.children.push();
if (isLeaf) {
current.style.display = 'none';
}
return childDom;
}
onFiltered () {}
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
initSpread($event: any) {
let spread = $event.spread;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let cityCount = cities.length;
let rowCount = sheet.getRowCount();
sheet.setValue(0, 0, 'Continent');
sheet.setValue(0, 1, 'Country');
sheet.setValue(0, 2, 'City');
sheet.setValue(0, 3, 'Amount');
for (let row = 1; row < rowCount; row++) {
let cityIndex = Math.floor(cityCount * Math.random());
let city = cities[cityIndex];
let country = getCountry(city);
let continent = getContinent(country);
sheet.setValue(row, 0, continent);
sheet.setValue(row, 1, country);
sheet.setValue(row, 2, city);
sheet.setValue(row, 3, Math.floor(10000 * Math.random()));
}
sheet.tables.add('table1', 0, 0, rowCount, 4, GC.Spread.Sheets.Tables.TableThemes.light19);
sheet.resumePaint();
let table = sheet.tables.find(0, 0);
let dataSource = new TreeSlicerData(table, [ 'Continent', 'Country', 'City' ]);
let treeSlicer = new TreeSlicer(dataSource, [ 'Continent', 'Country', 'City' ]);
document.getElementById('slicer_Tree').appendChild(treeSlicer.getDOMElement());
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet [rowCount]="200">
<gc-column [width]="100"></gc-column>
<gc-column [width]="100"></gc-column>
<gc-column [width]="100"></gc-column>
<gc-column [width]="100"></gc-column>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p class="desc">Click on different items in this tree to filter by those items.</p>
<div class="slicer-tree-container">
<div id="slicer_Tree"></div>
</div>
</div>
</div>
.hover {
background-color: lightgray;
font-weight: 700 !important;
}
.select {
font-weight: 700 !important;
color: blue;
}
.active {
font-weight: 700 !important;
color: red;
}
.treeSlicer_Item {
cursor: pointer;
}
.expanded {
background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAR0lEQVRYR+3UUQ0AIAwD0Zsi/LsYiiDDRPm4GWjzkrUIX4XzsYACCiigwAg0sEKT3FPghMJfrAUU+EIg+YbbJVRAAQUUUOAC99IJunjjuhUAAAAASUVORK5CYII=);
background-repeat: no-repeat;
background-position: center;
background-size: 10px 10px;
background-color: #d3d3d3;
height: 16px;
width: 16px;
float: left;
cursor: pointer;
}
.collapsed {
background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAaklEQVRYR+2WSwrAIBQD44na3v8SeqIWodsq000/jFuT8BgwvhJ+apLlwtbvNhJZiPjU7hMPykRiB5CABCTwWwKjbr/R1MhSexXPuh0lUrEDSOAVBJ58hs2NSAISkIAEPklg9He0JCvZig6rOyO69wJo3QAAAABJRU5ErkJggg==);
background-repeat: no-repeat;
background-position: center;
background-size: 10px 10px;
background-color: #d3d3d3;
height: 16px;
width: 16px;
float: left;
cursor: pointer;
}
li {
list-style: none;
}
.desc{
padding:2px 10px;
background-color:#F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
span {
line-height: 18px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.slicer-tree-container {
height: 440px;
position: relative;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.0-master-2026-05-10-2130/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);